;;;; launch-process.scm
;;;; Kon Lovett, Jul '06

;;Issues
;;
;; - Doesn't support remote connections of spawned process stdin/stdout;
;; i.e. remote-pipe.

(use miscmacros misc-extn-list lookup-table synch osprocess)

;;;

(define last-process-exception
  (let ([last-exp #f])
    (lambda args
      (if (not-null? args)
        (begin0
          last-exp
          (set! last-exp (car args)))
        last-exp ) ) ) )

(define *processes* (make-object/synch (make-dict fx=) 'processes))

(define (process-started? pid)
  (%let/synch ([dict *processes*])
    (and-let* ([osp (dict-ref dict pid)])
      (and (osprocess-started? osp)
           (list (seconds->utc-time (osprocess-start-seconds osp))) ) ) ) )

(define (start-process! cmd args)
  (last-process-exception #f)
  (handle-exceptions exp
    (begin
      (last-process-exception exp)
      #f)
    (receive [pid in out err osp] (osprocess cmd #:arguments args)
      (%let/synch ([dict *processes*])
        (dict-set! dict pid osp) )
      pid ) ) )

(define (reap-process! pid)
  (last-process-exception #f)
  (handle-exceptions exp
    (begin
      (last-process-exception exp)
      #f)
    (%let/synch ([dict *processes*])
      (and-let* ([osp (dict-ref dict pid)])
        (receive [epid enorm ecode] (osprocess-wait osp #t)
          (and (fx< 0 epid)
            (begin
              (dict-delete! dict pid)
              (list enorm ecode (seconds->utc-time (osprocess-exit-seconds osp)))) ) ) ) ) ) )

(define (shutdown-process! pid)
  (last-process-exception #f)
  (handle-exceptions exp
    (begin
      (last-process-exception exp)
      #f)
    (%let/synch ([dict *processes*])
      (and-let* ([osp (dict-ref dict pid)])
        (and (not (osprocess-exited? osp))
          (begin
            #+windows (void)
            #+unix (osprocess-kill osp)
            #t ) ) ) ) ) )
