;;;; remote-launch-common.scm
;;;; Kon Lovett, Jul '06

(use files)

;;;

(define-constant DEFAULT-REMOTE-LAUNCH-PORT 4001)

(define *cert-directory* (make-pathname (repository-path) "remote-launch-private"))
(define *cert-chain-pathname* (make-pathname *cert-directory* "server-certs.pem"))
(define *priv-key-pathname* (make-pathname *cert-directory* "server-privs.pem"))
(define *certs-pathname* (make-pathname *cert-directory* "client-certs.pem"))

;;;

(define-inline (valid-port? obj)
  (and (fixnum? obj) (< 0 obj 65536)) )

(define-inline (valid-ssl-protocol? obj)
  (memq obj '(sslv2-or-v3 sslv2 sslv3 tls)) )

(define-inline (valid-ssl-protocol-argument? obj)
  (or (valid-ssl-protocol? obj) (eq? obj 'none)) )

;;;

(define-inline (request-packet-operation req)
  (first req) )

(define-inline (request-packet-sender req)
  (second req) )

(define-inline (request-packet-sender-address req)
  (first (request-packet-sender req)) )

(define-inline (request-packet-sender-name req)
  (second (request-packet-sender req)) )

(define-inline (request-packet-serial req)
  (third req) )

(define-inline (request-packet-arguments req)
  (drop req 3) )

;;;

(define-inline (response-packet-operation rsp)
  (first rsp) )

(define-inline (response-packet-sender rsp)
  (second rsp) )

(define-inline (response-packet-sender-address rsp)
  (first (response-packet-sender rsp)) )

(define-inline (response-packet-sender-port rsp)
  (second (response-packet-sender rsp)) )

(define-inline (response-packet-receiver rsp)
  (third rsp) )

(define-inline (response-packet-receiver-address rsp)
  (first (response-packet-receiver rsp)) )

(define-inline (response-packet-receiver-name rsp)
  (second (response-packet-receiver rsp)) )

(define-inline (response-packet-serial rsp)
  (fourth rsp) )

(define-inline (response-packet-arguments rsp)
  (drop rsp 4) )

(define-inline (error-response-packet? rsp)
  (eq? 'error (response-packet-operation rsp)) )
